#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
using namespace std;

using ll = int64_t;
int n;

inline int map(int a, int b) {
	int c = (a - b);
	if (c < 0) 
		return c + n;
	return c;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int f;
	cin >> n >> f;

	vector<int> d(n);

	if (f == 1) {
		for (int i = 0; i < n; i++)
			cin >> d[i];
	}
	else if (f == 2) {
		int m;
		cin >> m;
		ll x, y, z;
		cin >> x >> y >> z;
		for (int i = 0; i < m; i++)
			cin >> d[i];

		for (int i = m; i < n; i++)
		{
			d[i] = ((x*d[i - 2] + y * d[i - 1] + z) % (int)1e9) + 1;
		}
	}

	int maxd;

	int mind = INT32_MAX;
	int mini = -1;

	for (int i = 0, tid; i < n; i++)
	{
		maxd = -1;
		for (int j = 0; j < n; j++)
		{
			tid = map(j, i);
			maxd = max(maxd, d[j] - tid);
		}
		if (maxd < mind) {
			mind = maxd;
			mini = i;
		}
	}

	cout << mind << ' ' << (mini + 1);

	return 0;
}

/*
5
1
3 7 4 2 5
*/
/*
10
2
5 1 2 3
 1 2 3 4 5
*/