#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;

using var = int64_t;

inline int sq(int x, int y) { return x * x + y * y; }

inline int64_t comb(int a, int b, int c, int d) {
	union {
		struct {
			unsigned short A, B, C, D;
		};
		int64_t r;
	};
	A = a;
	B = b;
	C = c;
	D = d;

	return r;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n, t;
	cin >> t >> n;

	vector<pair<var, int>> v(n*3);

	for (int i = 0, x1, x2, x3, y1, y2, y3; i < n; i++)
	{
		cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

		v[3 * i] = { sq(x2 - x1, y2 - y1), i };
		v[3 * i + 1] = { sq(x3 - x2, y3 - y2), i };
		v[3 * i + 2] = { sq(x1 - x3, y1 - y3), i };
	}
	auto xxx = [](const pair<var, int> &a, const pair<var, int> &b) {
		return a.first < b.first;
	};

	vector<pair<var, int>> v0 = v;
	sort(v0.begin(), v0.end(), xxx);

	v0.push_back({ -1,-1 });	  
	v0.push_back({ -1,-1 });	  
	v0.push_back({ -1,-1 });	  

	set<int64_t> ses;

	for (int i = 0; i < n; i++)
	{
		auto a = lower_bound(v0.begin(), v0.end(), v[3 * i],xxx);   
		//if ((a + 1)->first != a->first) continue;
		auto b = lower_bound(v0.begin(), v0.end(), v[3 * i +1],xxx);
		//if ((b + 1)->first != b->first) continue;
		auto c = lower_bound(v0.begin(), v0.end(), v[3 * i +2],xxx);
		//if ((c + 1)->first != c->first) continue;

		auto a0 = *a, b0 = *b, c0 = *c;

		auto bb = b, cc = c;

		while (a0.first == a->first)
		{
			b = bb;
			if (a->second != i)
				while (b0.first == b->first) {
					c = cc;
					if (b->second != i && b->second != a->second)
						while (c0.first == c->first) {
							if (c->second != i && c->second != b->second && c->second != a->second) {

								int arr[] = { a->second, b->second, c->second, i };

								sort(arr, arr + 4);

								ses.insert(comb(
									arr[0],
									arr[1],
									arr[2],
									arr[3]
								));
							}
							c++;
						}
					b++;
				}
			a++;
		}
	}

	cout << ses.size() << '\n';

	for (auto & _ : ses) {
		union {
			struct {
				unsigned short a, b, c, d;
			};
			int64_t r;
		};
		r = _;
		cout << a+1 << ' ' << b+1 << ' ' << c+1 << ' ' << d+1<< '\n';
	}

	return 0;
}
/*
1 4
0 0 6 2 1 2
0 0 5 0 6 3
0 0 3 1 1 3
0 0 6 3 3 6
*/