#include <string>
#include <vector>
#include <algorithm>
#include <iostream>
#include <numeric>
using namespace std;
using var = int64_t;

int main()
{
	int n, q;
	cin >> n >> q;

	vector<var> a(n), b(n);

	for (auto &_ : a) cin >> _;
	for (auto &_ : b) cin >> _;

	sort(a.begin(), a.end());
	sort(b.begin(), b.end());

	vector<pair<var, var>> d(min(n*n, (int)1e5));
	int x = d.size() / n;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < x; j++)
		{
			d[i*x + j] = { a[i], b[j] };
		}
	}

	sort(d.begin(), d.end(), [](pair<var, var> a, pair<var, var>b) {
		return a.first*b.second < a.second*b.first;
	});

	for (auto _ : d)cout << _.first << " " << _.second << endl;

	for (int i = 0, t; i < q; i++)
	{
		cin >> t;

		t--;

		int g = gcd(d[t].first, d[t].second);
		cout << d[t].first / g << " " << d[t].second / g << '\n';
	}




	return 0;
}