#include <string>
#include <vector>
#include <algorithm>
#include <iostream>
#include <numeric>
using namespace std;
using var = int64_t;

int main()
{
	int n, q;
	cin >> n >> q;

	vector<pair<var, var>> a(n);

	for (auto &_ : a) cin >> _.first;
	for (auto &_ : a) cin >> _.second;

	sort(a.begin(), a.end(), [](pair<var, var> b, pair<var, var> c) {
		return b.first * c.second < c.first * b.second;
	});

	vector<pair<var, var>> d(min(n*n, (int)1e7));

	for (int i = 0; i < n; i++)
	{
			if (i*n > d.size()) break;
		for (int j = 0; j < n; j++)
		{
			if (i*n + j > d.size()) break;
			d[i*n + j] = { a[i].first, a[j].second };
		}
	}

	sort(d.begin(), d.end(), [](pair<var, var> a, pair<var, var>b) {
		return a.first*b.second < a.second*b.first;
	});


	for (int i = 0, t; i < q; i++)
	{
		cin >> t;

		t--;

		int g = gcd(d[t].first, d[t].second);
		cout << d[t].first / g << " " << d[t].second / g << '\n';
	}




	return 0;
}