#include <string>
#include <vector>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <iterator>
#include <queue>
using namespace std;
using var = int64_t;

template<class T>
class pqueue : public priority_queue<T, vector<T>, greater<T>>  {
public:
	auto& last() {
		return this->c[this->c.size()-1];
	}
};

int main()
{
	int n, k;
	cin >> n >> k;

	vector<int> a(n);
	for (auto&_ : a)cin >> _;

	var best = 0;

	for (int l = 0; l < n - k; l++)
	{
		priority_queue<int, vector<int>, greater<int>> q;

		for (int i = 0; i < k; i++)
			q.push(a[i + l]);
		if (k == 0) q.push(2+(int)1e9);

		var hap = 0;

		for (int r = l+k; r < n; r++)
		{
			int t = a[r];
			if (q.top() < a[r]) {
				hap += q.top();
				q.pop();
				q.push(a[r]);
			}
			else {
				hap += a[r];
			}
			if (hap > best)
				best = hap;
		}
	}

	cout << best;

	return 0;
}
/*
4 8
3 4 1 2
2 3 4 5

1 16 2 4 5 6 10 15
*/
/*
  5 0
  2 -4 5 -1 7

  5 1
  2 -4 5 -1 7

  5 2
  2 -4 5 -1 7
*/
//9 2 1 2 3 0 -2 5 8 -3 18