#include <string>
#include <vector>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <iterator>
#include <queue>
using namespace std;
using var = int64_t;

template<class T>
class pqueue : public priority_queue<T, vector<T>, greater<T>> {
public:
	auto& last() {
		return this->c[this->c.size() - 1];
	}
};

int main()
{
	int n, k;
	cin >> n >> k;

	vector<int> a(n);
	for (auto&_ : a)cin >> _;

	var best = 0;
	var lt = 0, rt = 0;

	for (int l = 0; l < n - k; l++)
	{

		for (int r = l + k; r < n; r++)
		{
			vector<int> tmp(a.begin() + l, a.begin() + r+1);

			sort(tmp.begin(), tmp.end());
			var h = 0;
			for (int i = 0; i < tmp.size() - k; i++)
			{
				h += tmp[i];
			}
			if (h > best) best = h;
		}
	}

	cout << best << endl;

	return 0;
}
/*
4 8
3 4 1 2
2 3 4 5

1 16 2 4 5 6 10 15
*/
/*
5 0
2 -4 5 -1 7

5 1
2 -4 5 -1 7

5 2
2 -4 5 -1 7
*/
//9 2 1 2 3 0 -2 5 8 -3 18
// 9 2 14 15 -89 89 48 -45 153 -45