#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
using namespace std;

using ll = int64_t;

vector<int> a;
int beg = 0;
int n, q;

inline auto& get(int id) {
	return a[((id)+beg) % n];
}
inline auto shift(int delta) {
	beg = (beg - delta) % n;
	if (beg < 0)
		beg += n;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cin >> n;

	 a.resize(n);

	ll sum = 0;

	for (auto &_ : a) {
		cin >> _;
		sum += _;
	}

	cin >> q;

	int k, x;

	for (int i = 0, comm; i < q; i++)
	{
		cin >> comm;

		if (comm == 1) {
			cin >> k >> x;

			int & gt = get(--k);
			sum -= gt;
			sum += x;

			gt = x;

			cout << sum << '\n';
		}
		else
		{
			cin >> k;

			shift(k);

			cout << sum << '\n';
		}
	}

	return 0;
}

/*
6
4 1 2 1 5 3
5
2 3 
1 3 10
1 4 4 
2 1 
1 1 -10
*/