﻿#include <string>
#include <vector>
#include <algorithm>
#include <iostream>
#include <numeric>
using namespace std;
using var = int64_t;

int main()
{
	int n, q;
	cin >> n >> q;

	vector<var> a(n), b(n);

	for (auto &_ : a) cin >> _;
	for (auto &_ : b) cin >> _;

	sort(a.begin(), a.end());
	sort(b.begin(), b.end());

	vector<pair<var, var>> d(max(n*n, 2+(int)1e6));

	for (int i = 0; i < n; i++)
	{
		if (i*n > d.size()) break;
		for (int j = 0; j < n; j++)
		{
		if (i*n+j > d.size()) break;
			d[i*n + j] = { a[i], b[j] };
		}
	}

	sort(d.begin(), d.end(), [](pair<var, var> a, pair<var, var>b) {
		return a.first*b.second < a.second*b.first;
	});

	for (int i = 0, t; i < q; i++)
	{
		cin >> t;

		t--;

		int g = gcd(d[t].first, d[t].second);
		cout << d[t].first / g << " " << d[t].second / g << '\n';
	}




	return 0;
}
/*
4 8
3 4 1 2
2 3 4 5
 
1 16 2 4 5 6 10 15
*/